#
# spec file for package perl-autovivification
#
# Copyright (c) 2013 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           perl-autovivification
Version:        0.12
Release:        4.3
%define cpan_name autovivification
Summary:        Lexically disable autovivification.
License:        Artistic-1.0 or GPL-1.0+
Group:          Development/Libraries/Perl
Url:            http://search.cpan.org/dist/autovivification/
Source:         http://www.cpan.org/authors/id/V/VP/VPIT/%{cpan_name}-%{version}.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  perl
BuildRequires:  perl-macros
#BuildRequires: perl(autovivification)
#BuildRequires: perl(autovivification::TestCases)
#BuildRequires: perl(autovivification::TestRequired1)
#BuildRequires: perl(autovivification::TestRequired4::b0)
#BuildRequires: perl(autovivification::TestRequired5::b0)
#BuildRequires: perl(autovivification::TestRequired5::d0)
#BuildRequires: perl(autovivification::TestRequired6)
#BuildRequires: perl(autovivification::TestThreads)
#BuildRequires: perl(Test::Leaner)
#BuildRequires: perl(VPIT::TestHelpers)
%{perl_requires}

%description
When an undefined variable is dereferenced, it gets silently upgraded to an
array or hash reference (depending of the type of the dereferencing). This
behaviour is called _autovivification_ and usually does what you mean (e.g.
when you store a value) but it may be unnatural or surprising because your
variables gets populated behind your back. This is especially true when
several levels of dereferencing are involved, in which case all levels are
vivified up to the last, or when it happens in intuitively read-only
constructs like 'exists'.

This pragma lets you disable autovivification for some constructs and
optionally throws a warning or an error when it would have happened.

%prep
%setup -q -n %{cpan_name}-%{version}

%build
%{__perl} Makefile.PL INSTALLDIRS=vendor OPTIMIZE="%{optflags}"
%{__make} %{?_smp_mflags}

%check
%{__make} test

%install
%perl_make_install
%perl_process_packlist
%perl_gen_filelist

%files -f %{name}.files
%defattr(-,root,root,755)
%doc Changes README

%changelog
* Fri Oct  4 2013 coolo@suse.com
- updated to 0.12
    + Fix : Check functions are now replaced and restored in a thread-safe
    manner, either by using the wrap_op_checker() function from perl
    when it is available (starting from perl 5.16) or by taking the
    OP_REFCNT mutex on older perls.
    + Tst : Author tests are no longer bundled with this distribution.
    They are only made available to authors in the git repository.
* Mon Sep  2 2013 werner@suse.de
- Update to version 0.11
  + Doc : POD tweaks and clarifications.
  + Tst : Threads tests will not fail anymore if resources constraints
    prevent the system from creating all the required threads.
  + Tst : Author tests overhaul.
  + Fix : The pragma no longer vivifies the "autovivification" entry
    in the hints hash %%^H on perl 5.8.
* Thu Apr 14 2011 coolo@opensuse.org
- initial package 0.09
  * created by cpanspec 1.78.04
